#include<stdio.h>
#define MAX_N 5005
#define oo 999999999

int n, t [MAX_N], v [MAX_N], L, p [MAX_N];
bool mark [MAX_N];
double tDisk [MAX_N];

	void input()
	{
		scanf ("%d", &L);
		scanf ("%d", &n);
		for (int i = 0; i < n; i++)
			scanf ("%d %d", &t [i], &v [i]);
	}

	double min (double a, double b)
	{
		if (a > b)
			return b;
		return a;
	}

	void solve()
	{
		for (int i = 0; i < n; i++)
		{
			tDisk [i] = oo;
			mark [i] = true;
		}

		double T = oo;
		double Ld = L;
		for (int i = 0; i < n; i++)
			T = min (T, t [i] + Ld / v [i]);

		for (int i = 0; i < n; i++)
			if (t [i] >= T)
			{
				tDisk [i] = T;
				mark [i] = false;
			}

		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if ((t [i] <= t [j]) && (mark [i] & mark [j] == true))
				{
					double dist = ((t [j] - t [i]) * v [i]) % L;
					if (v [i] > v [j])
					{
						double tmp = (L - dist) / (v [i] - v [j]);
						tDisk [j] = min (tDisk [j], t [j] + tmp);
					}
					if (v [i] < v [j])
					{
						double tmp = dist / (v [j] - v [i]);
						tDisk [i] = min (tDisk [i], t [j] + tmp);
					}
				}

		for (int i = 0; i < n; i++)
			p [i] = i;
		for (int i = 0; i < n; i++)
			for (int j = i + 1; j < n; j++)
				if ((tDisk [p [i]] > tDisk [p [j]]) || 
				   ((tDisk [p [i]] == tDisk [p [j]]) && (p [j] < p [i])))
				{
					int tmp = p [i];
					p [i] = p [j];
					p [j] = tmp;
				}
	}

	void output()
	{
		int k = 0;
		while ((tDisk [p [k]] != oo) && (k < n))
		{
			printf("%d\n", p [k] + 1);
			k++;
		} 
	}

	int main()
	{
		input();
		solve();
		output();

		return 0;
	}


